SystemOrganization addCategory: #'1er-TP'!

Trait named: #CRT
	uses: {}
	category: '1er-TP'!

Trait named: #MonitorPC
	uses: {}
	category: '1er-TP'!

!MonitorPC methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:12'!
tasaDeRefresco
^120.! !

Trait named: #TV
	uses: {}
	category: '1er-TP'!

Trait named: #TecnologiaDigital
	uses: {}
	category: '1er-TP'!

Trait named: #LCD
	uses: TecnologiaDigital
	category: '1er-TP'!

LCD classTrait
	uses: TecnologiaDigital classTrait!

!LCD methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:42'!
consumoSinEntrada
^(4*self tamanio).! !

!LCD methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:20'!
tamanio
self requirement.! !

Trait named: #LED
	uses: TecnologiaDigital
	category: '1er-TP'!

LED classTrait
	uses: TecnologiaDigital classTrait!

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:37'!
pixelesPorPulgada
self requirement.! !

Trait named: #tConGPU
	uses: {}
	category: '1er-TP'!

!tConGPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/8/2013 18:58'!
AptoParaJuegos
	"Responde si la placa de video con GPU es apta para videojuegos"
	^true.! !

!tConGPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:42'!
consume
	"Calcula el consumo de una placa de video con GPU."

	| resultado |
	resultado := (( self pxAltura * self pxBase ) * 0.00001) + self consumoDeCoolers.
	^resultado.! !

Trait named: #tMagnetico
	uses: {}
	category: '1er-TP'!

!tMagnetico methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:42'!
consume
	"Calcula el consumo de un disco rigido magnetico."

	| resultado |
	resultado := self rpm * 0.006.
	^resultado.! !

Trait named: #tOnBoard
	uses: {}
	category: '1er-TP'!

!tOnBoard methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/8/2013 19:08'!
AptoParaJuegos
	"Responde si la placa de video onboard es apta para videojuegos"
	^false.! !

!tOnBoard methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:17'!
consume
	"Calcula el consumo de una placa de video onboard. 
	CONSTANTE"
	^self consumo + self consumoDeCoolers.! !

Trait named: #tSinGPU
	uses: {}
	category: '1er-TP'!

!tSinGPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/8/2013 20:19'!
AptoParaJuegos
	"Responde si la placa de video sin GPU es apta para videojuegos"
	| resultado |
	resultado := ((self pxAltura * self pxBase) / self consume) > 4 .
	^resultado.! !

!tSinGPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:17'!
consume
	"Calcula el consumo de una placa de video sin GPU.
	CONSTANTE"
	^self consumo + self consumoDeCoolers.! !

Trait named: #tSolido
	uses: {}
	category: '1er-TP'!

!tSolido methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/8/2013 22:36'!
consume
	"Calcula el consumo de un disco rigido de estado solido.
	CONSTANTE."

	^self consumo.! !

TestCase subclass: #TPTests
	instanceVariableNames: 'lg19Widescreen philips32'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!TPTests class methodsFor: 'history' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:58'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #test5ConsumoDiscoMagnetico; add: #test5ConsumoPlacaOnBoard; add: #test5ConsumoPlacaConGPU; add: #test5ConsumoPlacaSinGPU; add: #test5ConsumoDiscoSolido; add: #test5ConsumoPC; yourself)); add: (#failures->((Set new) add: #testConsumoSegunEntrada; yourself)); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 14280; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2456396; instVarAt: 4 put: 959000000; yourself)); yourself)! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 07:37'!
setUp

	lg19Widescreen := MonitorLCD new.
	lg19Widescreen tamanio:19.
	lg19Widescreen pixelesPorPulgada:100.
	
	philips32 := SmartTV new.
	philips32 tamanio: 32.
	philips32 pixelesPorPulgada: 200.
	
	! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:09'!
test5ConsumoDiscoMagnetico
	" Testeo del consumo de un disco magnetico."

	| unDisco |

	unDisco := Magnetico newConRPM: 7000.
	
	self assert: unDisco consume = 42.
! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:10'!
test5ConsumoDiscoSolido
	" Testeo del consumo de un disco solido."

	| unDisco |

	unDisco := Solido newConRPM: 7000.
	
	self assert: unDisco consume = 10.
! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:36'!
test5ConsumoPC
	" Testeo del consumo total de una computadora completa."

	| unCPU unDisco unaPdV |

	unaPdV := ConGPU newDe: 1366 Por: 768 Con: 5.
	unDisco := Solido newConRPM: 7000.
	unCPU := CPU newConDisco: unDisco yPlaca: unaPdV.
	
	self assert: unCPU consume = 22.99088

! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:10'!
test5ConsumoPlacaConGPU
	" Testeo del consumo de una placa de video con GPU."

	| unaPdV |

	unaPdV := ConGPU newDe: 1366 Por: 768 Con: 5.
	
	self assert: unaPdV consume = 12.99088
! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:35'!
test5ConsumoPlacaOnBoard
	" Testeo del consumo de una placa de video onBoard."

	| unaPdV |

	unaPdV := OnBoard newDe: 1366 Por: 768 Con: 5 YConsume: 15.
	
	self assert: unaPdV consume = 17.5
! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:34'!
test5ConsumoPlacaSinGPU
	" Testeo del consumo de una placa de video sin GPU."

	| unaPdV |

	unaPdV := SinGPU newDe: 1366 Por: 768 Con: 5.
	
	self assert: unaPdV consume = 12.5
! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 04:03'!
testConsumoSegunEntrada
	
	| entrada |
	entrada := EntradaVGA new.
	entrada pixeles: 1366.
	lg19Widescreen entrada: entrada.
	self assert: (lg19Widescreen consumoPorHora) equals: ((4*19) + (0.001*1366)).! !

!TPTests methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/14/2013 07:30'!
testConsumoSegunEntrada2
	
	| entrada |
	entrada := EntradaHDMI new.
	entrada pixeles: 1366.
	lg19Widescreen entrada: entrada.
	self assert: (lg19Widescreen consumoPorHora) equals: ((4*19) + (0.001*1366)).! !

Object subclass: #CPU
	instanceVariableNames: 'PlacaDeVideo Disco'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!CPU class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:36'!
newConDisco: unDisco yPlaca: unaPlaca
	"Crea un CPU con un disco y placa especifica"

	|newCPU|

	newCPU := self new.
	newCPU disco: unDisco.
	newCPU placaDeVideo: unaPlaca.
	^ newCPU.! !

!CPU methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:49'!
consume
	"consumo total del CPU"

	| consumoTT |
	consumoTT := self disco consume + self placaDeVideo consume.
	^consumoTT.! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
disco
	^ Disco! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
disco: anObject
	Disco := anObject! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
placaDeVideo
	^ PlacaDeVideo! !

!CPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:34'!
placaDeVideo: anObject
	PlacaDeVideo := anObject! !

Object subclass: #Disco
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!Disco commentStamp: '<historical>' prior: 0!
A Disco is xxxxxxxxx.

Instance Variables
	rpm:		<Object>

rpm
	- Revoluciones por minutos del disco
!

!Disco class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:35'!
newConRPM: unRPM
	"Crea un disco con un RPM especifico"

	|newDisco|

	newDisco := self new.
	newDisco rpm: unRPM.
	^ newDisco.! !

!Disco methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:56'!
rpm
	^ rpm! !

!Disco methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 17:56'!
rpm: anObject
	rpm := anObject! !

Disco subclass: #Magnetico
	uses: tMagnetico
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

Magnetico class
	uses: tMagnetico classTrait
	instanceVariableNames: ''!

Disco subclass: #Solido
	uses: tSolido
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

Solido class
	uses: tSolido classTrait
	instanceVariableNames: ''!

!Solido class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:36'!
newConRPM: unRPM
	"Crea un disco con un RPM especifico con 10 watt/h"

	|newDisco|

	newDisco := self new.
	newDisco rpm: unRPM.
	newDisco consumo: 10.
	^ newDisco.! !

!Solido class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:36'!
newConRPM: unRPM Y: unConsumo
	"Crea un disco con un RPM y un consumo especifico"

	|newDisco|

	newDisco := self new.
	newDisco rpm: unRPM.
	newDisco consumo: unConsumo.
	^ newDisco.! !

!Solido methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 22:36'!
consumo
	^ consumo! !

!Solido methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 22:36'!
consumo: anObject
	consumo := anObject! !

Object subclass: #Entrada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!Entrada methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:27'!
pixeles
^480! !

Entrada subclass: #EntradaHDMI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

Entrada subclass: #EntradaVGA
	instanceVariableNames: 'pixeles'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!EntradaVGA methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:44'!
consumoPorHora
^(0.001*self pixeles).! !

!EntradaVGA methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:25'!
pixeles
^pixeles.! !

!EntradaVGA methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:28'!
pixeles: unosPixeles
pixeles:=unosPixeles.! !

Object subclass: #Pantalla
	instanceVariableNames: 'tamanio entrada ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

Pantalla subclass: #MonitorLCD
	uses: MonitorPC + LCD - {#pixelesPorPulgadatamanio. #tamanio}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!MonitorLCD commentStamp: '<historical>' prior: 0!
Un MonitorLCD es la combinacin de esas dos cosas usando Traits.!

MonitorLCD class
	uses: MonitorPC classTrait + LCD classTrait
	instanceVariableNames: ''!

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:59'!
consumoPorHora 
^self consumoSinEntrada + entrada consumoPorHora.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:09'!
entrada
^entrada.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:54'!
entrada: unaEntrada.
entrada := unaEntrada.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:38'!
pixelesPorPulgada
^ppp.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:38'!
pixelesPorPulgada:pixeles
ppp:=pixeles.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:07'!
tamanio
^tamanio.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'SantiagoOcchiuzzi 4/13/2013 03:07'!
tamanio: pulgadas
tamanio := pulgadas.! !

Pantalla subclass: #SmartTV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!SmartTV commentStamp: '<historical>' prior: 0!
Es casi igual que un TV LED. Difiere en la tasa de refresco, y se abre a futuros nuevos requerimientos :)!

Object subclass: #PlacaDeVideo
	instanceVariableNames: 'pxAltura pxBase nroDeCoolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

!PlacaDeVideo commentStamp: '<historical>' prior: 0!
A PlacaDeVideo is xxxxxxxxx.

Instance Variables
	nroDeCoolers:		<Object>
	pxAltura:		<Object>
	pxBase:		<Object>

nroDeCoolers
	- Cantidad de coolers de la placa

pxAltura
	- Altura de la resolucion, medida en cantidad de pixeles
	
Resolucion
	- Base de la resolucion, medida en cantidad de pixeles
!

PlacaDeVideo subclass: #ConGPU
	uses: tConGPU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

ConGPU class
	uses: tConGPU classTrait
	instanceVariableNames: ''!

PlacaDeVideo subclass: #OnBoard
	uses: tOnBoard
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

OnBoard class
	uses: tOnBoard classTrait
	instanceVariableNames: ''!

!OnBoard class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:31'!
newDe: unAlto Por: unaBase Con: CantDeCoolers
	"Crea una placa de video con una resolucion y cantidad de coolers especificas y un consumo constante de 10 watts/h"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unAlto.
	newPdV pxBase: unaBase.
	newPdV nroDeCoolers: CantDeCoolers.
	newPdV consumo: 10.
	^ newPdV.! !

!OnBoard class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:33'!
newDe: unAlto Por: unaBase Con: CantDeCoolers YConsume: unConsumo
	"Crea una placa de video con una resolucion, cantidad de coolers y consumo especificas"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unAlto.
	newPdV pxBase: unaBase.
	newPdV nroDeCoolers: CantDeCoolers.
	newPdV consumo: unConsumo.
	^ newPdV.! !

!OnBoard methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 23:46'!
consumo
	^ consumo! !

!OnBoard methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 23:46'!
consumo: anObject
	consumo := anObject! !

!PlacaDeVideo class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:35'!
newDe: unAlto Por: unaBase Con: CantDeCoolers
	"Crea una placa de video con una resolucion y cantidad de coolers especificas"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unAlto.
	newPdV pxBase: unaBase.
	newPdV nroDeCoolers: CantDeCoolers.
	^ newPdV.! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 00:15'!
consumoDeCoolers
	"Calcula el consumo de los coolers"
	^(nroDeCoolers * 0.5).! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:46'!
nroDeCoolers
	^ nroDeCoolers! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:46'!
nroDeCoolers: anObject
	nroDeCoolers := anObject! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:44'!
pxAltura
	^ pxAltura! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:44'!
pxAltura: anObject
	pxAltura := anObject! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:44'!
pxBase
	^ pxBase! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 19:44'!
pxBase: anObject
	pxBase := anObject! !

PlacaDeVideo subclass: #SinGPU
	uses: tSinGPU
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: '1er-TP'!

SinGPU class
	uses: tSinGPU classTrait
	instanceVariableNames: ''!

!SinGPU class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:30'!
newDe: unAlto Por: unaBase Con: CantDeCoolers
	"Crea una placa de video con una resolucion y cantidad de coolers especificas y un consumo constante de 10 watts/h"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unAlto.
	newPdV pxBase: unaBase.
	newPdV nroDeCoolers: CantDeCoolers.
	newPdV consumo: 10.
	^ newPdV.! !

!SinGPU class methodsFor: 'as yet unclassified' stamp: 'Anonymous 4/9/2013 01:33'!
newDe: unAlto Por: unaBase Con: CantDeCoolers YConsume: unConsumo
	"Crea una placa de video con una resolucion, cantidad de coolers y consumo especificas"

	|newPdV|

	newPdV := self new.
	newPdV pxAltura: unAlto.
	newPdV pxBase: unaBase.
	newPdV nroDeCoolers: CantDeCoolers.
	newPdV consumo: unConsumo.
	^ newPdV.! !

!SinGPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 23:47'!
consumo
	^ consumo! !

!SinGPU methodsFor: 'accessing' stamp: 'Anonymous 4/8/2013 23:47'!
consumo: anObject
	consumo := anObject! !
